// Generated by Apple Swift version 5.4.2 (swiftlang-1205.0.28.2 clang-1205.0.19.57)
#ifndef VIDYOCORE_SWIFT_H
#define VIDYOCORE_SWIFT_H
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wgcc-compat"

#if !defined(__has_include)
# define __has_include(x) 0
#endif
#if !defined(__has_attribute)
# define __has_attribute(x) 0
#endif
#if !defined(__has_feature)
# define __has_feature(x) 0
#endif
#if !defined(__has_warning)
# define __has_warning(x) 0
#endif

#if __has_include(<swift/objc-prologue.h>)
# include <swift/objc-prologue.h>
#endif

#pragma clang diagnostic ignored "-Wauto-import"
#include <Foundation/Foundation.h>
#include <stdint.h>
#include <stddef.h>
#include <stdbool.h>

#if !defined(SWIFT_TYPEDEFS)
# define SWIFT_TYPEDEFS 1
# if __has_include(<uchar.h>)
#  include <uchar.h>
# elif !defined(__cplusplus)
typedef uint_least16_t char16_t;
typedef uint_least32_t char32_t;
# endif
typedef float swift_float2  __attribute__((__ext_vector_type__(2)));
typedef float swift_float3  __attribute__((__ext_vector_type__(3)));
typedef float swift_float4  __attribute__((__ext_vector_type__(4)));
typedef double swift_double2  __attribute__((__ext_vector_type__(2)));
typedef double swift_double3  __attribute__((__ext_vector_type__(3)));
typedef double swift_double4  __attribute__((__ext_vector_type__(4)));
typedef int swift_int2  __attribute__((__ext_vector_type__(2)));
typedef int swift_int3  __attribute__((__ext_vector_type__(3)));
typedef int swift_int4  __attribute__((__ext_vector_type__(4)));
typedef unsigned int swift_uint2  __attribute__((__ext_vector_type__(2)));
typedef unsigned int swift_uint3  __attribute__((__ext_vector_type__(3)));
typedef unsigned int swift_uint4  __attribute__((__ext_vector_type__(4)));
#endif

#if !defined(SWIFT_PASTE)
# define SWIFT_PASTE_HELPER(x, y) x##y
# define SWIFT_PASTE(x, y) SWIFT_PASTE_HELPER(x, y)
#endif
#if !defined(SWIFT_METATYPE)
# define SWIFT_METATYPE(X) Class
#endif
#if !defined(SWIFT_CLASS_PROPERTY)
# if __has_feature(objc_class_property)
#  define SWIFT_CLASS_PROPERTY(...) __VA_ARGS__
# else
#  define SWIFT_CLASS_PROPERTY(...)
# endif
#endif

#if __has_attribute(objc_runtime_name)
# define SWIFT_RUNTIME_NAME(X) __attribute__((objc_runtime_name(X)))
#else
# define SWIFT_RUNTIME_NAME(X)
#endif
#if __has_attribute(swift_name)
# define SWIFT_COMPILE_NAME(X) __attribute__((swift_name(X)))
#else
# define SWIFT_COMPILE_NAME(X)
#endif
#if __has_attribute(objc_method_family)
# define SWIFT_METHOD_FAMILY(X) __attribute__((objc_method_family(X)))
#else
# define SWIFT_METHOD_FAMILY(X)
#endif
#if __has_attribute(noescape)
# define SWIFT_NOESCAPE __attribute__((noescape))
#else
# define SWIFT_NOESCAPE
#endif
#if __has_attribute(ns_consumed)
# define SWIFT_RELEASES_ARGUMENT __attribute__((ns_consumed))
#else
# define SWIFT_RELEASES_ARGUMENT
#endif
#if __has_attribute(warn_unused_result)
# define SWIFT_WARN_UNUSED_RESULT __attribute__((warn_unused_result))
#else
# define SWIFT_WARN_UNUSED_RESULT
#endif
#if __has_attribute(noreturn)
# define SWIFT_NORETURN __attribute__((noreturn))
#else
# define SWIFT_NORETURN
#endif
#if !defined(SWIFT_CLASS_EXTRA)
# define SWIFT_CLASS_EXTRA
#endif
#if !defined(SWIFT_PROTOCOL_EXTRA)
# define SWIFT_PROTOCOL_EXTRA
#endif
#if !defined(SWIFT_ENUM_EXTRA)
# define SWIFT_ENUM_EXTRA
#endif
#if !defined(SWIFT_CLASS)
# if __has_attribute(objc_subclassing_restricted)
#  define SWIFT_CLASS(SWIFT_NAME) SWIFT_RUNTIME_NAME(SWIFT_NAME) __attribute__((objc_subclassing_restricted)) SWIFT_CLASS_EXTRA
#  define SWIFT_CLASS_NAMED(SWIFT_NAME) __attribute__((objc_subclassing_restricted)) SWIFT_COMPILE_NAME(SWIFT_NAME) SWIFT_CLASS_EXTRA
# else
#  define SWIFT_CLASS(SWIFT_NAME) SWIFT_RUNTIME_NAME(SWIFT_NAME) SWIFT_CLASS_EXTRA
#  define SWIFT_CLASS_NAMED(SWIFT_NAME) SWIFT_COMPILE_NAME(SWIFT_NAME) SWIFT_CLASS_EXTRA
# endif
#endif
#if !defined(SWIFT_RESILIENT_CLASS)
# if __has_attribute(objc_class_stub)
#  define SWIFT_RESILIENT_CLASS(SWIFT_NAME) SWIFT_CLASS(SWIFT_NAME) __attribute__((objc_class_stub))
#  define SWIFT_RESILIENT_CLASS_NAMED(SWIFT_NAME) __attribute__((objc_class_stub)) SWIFT_CLASS_NAMED(SWIFT_NAME)
# else
#  define SWIFT_RESILIENT_CLASS(SWIFT_NAME) SWIFT_CLASS(SWIFT_NAME)
#  define SWIFT_RESILIENT_CLASS_NAMED(SWIFT_NAME) SWIFT_CLASS_NAMED(SWIFT_NAME)
# endif
#endif

#if !defined(SWIFT_PROTOCOL)
# define SWIFT_PROTOCOL(SWIFT_NAME) SWIFT_RUNTIME_NAME(SWIFT_NAME) SWIFT_PROTOCOL_EXTRA
# define SWIFT_PROTOCOL_NAMED(SWIFT_NAME) SWIFT_COMPILE_NAME(SWIFT_NAME) SWIFT_PROTOCOL_EXTRA
#endif

#if !defined(SWIFT_EXTENSION)
# define SWIFT_EXTENSION(M) SWIFT_PASTE(M##_Swift_, __LINE__)
#endif

#if !defined(OBJC_DESIGNATED_INITIALIZER)
# if __has_attribute(objc_designated_initializer)
#  define OBJC_DESIGNATED_INITIALIZER __attribute__((objc_designated_initializer))
# else
#  define OBJC_DESIGNATED_INITIALIZER
# endif
#endif
#if !defined(SWIFT_ENUM_ATTR)
# if defined(__has_attribute) && __has_attribute(enum_extensibility)
#  define SWIFT_ENUM_ATTR(_extensibility) __attribute__((enum_extensibility(_extensibility)))
# else
#  define SWIFT_ENUM_ATTR(_extensibility)
# endif
#endif
#if !defined(SWIFT_ENUM)
# define SWIFT_ENUM(_type, _name, _extensibility) enum _name : _type _name; enum SWIFT_ENUM_ATTR(_extensibility) SWIFT_ENUM_EXTRA _name : _type
# if __has_feature(generalized_swift_name)
#  define SWIFT_ENUM_NAMED(_type, _name, SWIFT_NAME, _extensibility) enum _name : _type _name SWIFT_COMPILE_NAME(SWIFT_NAME); enum SWIFT_COMPILE_NAME(SWIFT_NAME) SWIFT_ENUM_ATTR(_extensibility) SWIFT_ENUM_EXTRA _name : _type
# else
#  define SWIFT_ENUM_NAMED(_type, _name, SWIFT_NAME, _extensibility) SWIFT_ENUM(_type, _name, _extensibility)
# endif
#endif
#if !defined(SWIFT_UNAVAILABLE)
# define SWIFT_UNAVAILABLE __attribute__((unavailable))
#endif
#if !defined(SWIFT_UNAVAILABLE_MSG)
# define SWIFT_UNAVAILABLE_MSG(msg) __attribute__((unavailable(msg)))
#endif
#if !defined(SWIFT_AVAILABILITY)
# define SWIFT_AVAILABILITY(plat, ...) __attribute__((availability(plat, __VA_ARGS__)))
#endif
#if !defined(SWIFT_WEAK_IMPORT)
# define SWIFT_WEAK_IMPORT __attribute__((weak_import))
#endif
#if !defined(SWIFT_DEPRECATED)
# define SWIFT_DEPRECATED __attribute__((deprecated))
#endif
#if !defined(SWIFT_DEPRECATED_MSG)
# define SWIFT_DEPRECATED_MSG(...) __attribute__((deprecated(__VA_ARGS__)))
#endif
#if __has_feature(attribute_diagnose_if_objc)
# define SWIFT_DEPRECATED_OBJC(Msg) __attribute__((diagnose_if(1, Msg, "warning")))
#else
# define SWIFT_DEPRECATED_OBJC(Msg) SWIFT_DEPRECATED_MSG(Msg)
#endif
#if !defined(IBSegueAction)
# define IBSegueAction
#endif
#if __has_feature(modules)
#if __has_warning("-Watimport-in-framework-header")
#pragma clang diagnostic ignored "-Watimport-in-framework-header"
#endif
@import CoreGraphics;
@import Foundation;
@import ObjectiveC;
@import UIKit;
#endif

#pragma clang diagnostic ignored "-Wproperty-attribute-mismatch"
#pragma clang diagnostic ignored "-Wduplicate-method-arg"
#if __has_warning("-Wpragma-clang-attribute")
# pragma clang diagnostic ignored "-Wpragma-clang-attribute"
#endif
#pragma clang diagnostic ignored "-Wunknown-pragmas"
#pragma clang diagnostic ignored "-Wnullability"

#if __has_attribute(external_source_symbol)
# pragma push_macro("any")
# undef any
# pragma clang attribute push(__attribute__((external_source_symbol(language="Swift", defined_in="VidyoCore",generated_declaration))), apply_to=any(function,enum,objc_interface,objc_category,objc_protocol))
# pragma pop_macro("any")
#endif


SWIFT_CLASS("_TtC9VidyoCore5Delay")
@interface Delay : NSObject
- (nonnull instancetype)init SWIFT_UNAVAILABLE;
+ (nonnull instancetype)new SWIFT_UNAVAILABLE_MSG("-init is unavailable");
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly) NSTimeInterval Short;)
+ (NSTimeInterval)Short SWIFT_WARN_UNUSED_RESULT;
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly) NSTimeInterval Long;)
+ (NSTimeInterval)Long SWIFT_WARN_UNUSED_RESULT;
@end


@class NSString;
@class NSAttributedString;
@class NSNumber;
@class ToastView;

SWIFT_CLASS("_TtC9VidyoCore5Toast")
@interface Toast : NSOperation
@property (nonatomic, copy) NSString * _Nullable text;
@property (nonatomic, strong) NSAttributedString * _Nullable attributedText;
@property (nonatomic) NSTimeInterval delay;
@property (nonatomic) NSTimeInterval duration;
@property (nonatomic, getter=isExecuting) BOOL executing;
@property (nonatomic, getter=isFinished) BOOL finished;
@property (nonatomic, strong) ToastView * _Nonnull view;
/// Initializer.
/// Instantiates <code>self.view</code>, so must be called on main thread.
- (nonnull instancetype)initWithText:(NSString * _Nullable)text delay:(NSTimeInterval)delay duration:(NSTimeInterval)duration OBJC_DESIGNATED_INITIALIZER;
- (nonnull instancetype)initWithAttributedText:(NSAttributedString * _Nullable)attributedText delay:(NSTimeInterval)delay duration:(NSTimeInterval)duration OBJC_DESIGNATED_INITIALIZER;
- (void)show;
- (void)cancel;
- (void)start;
- (void)main;
- (nonnull instancetype)init SWIFT_UNAVAILABLE;
+ (nonnull instancetype)new SWIFT_UNAVAILABLE_MSG("-init is unavailable");
@end


SWIFT_CLASS("_TtC9VidyoCore11ToastCenter")
@interface ToastCenter : NSObject
/// If this value is <code>true</code> and the user is using VoiceOver,
/// VoiceOver will announce the text in the toast when <code>ToastView</code> is displayed.
@property (nonatomic) BOOL isSupportAccessibility;
/// By default, queueing for toast is enabled.
/// If this value is <code>false</code>, only the last requested toast will be shown.
@property (nonatomic) BOOL isQueueEnabled;
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, strong, getter=default) ToastCenter * _Nonnull default_;)
+ (ToastCenter * _Nonnull)default SWIFT_WARN_UNUSED_RESULT;
- (nonnull instancetype)init SWIFT_UNAVAILABLE;
+ (nonnull instancetype)new SWIFT_UNAVAILABLE_MSG("-init is unavailable");
- (void)cancelAll;
@end

@class UIColor;
@class UIFont;
@class NSCoder;
@class UIEvent;

SWIFT_CLASS("_TtC9VidyoCore9ToastView")
@interface ToastView : UIView
/// The background view’s color.
@property (nonatomic, strong) UIColor * _Nullable backgroundColor;
/// The background view’s corner radius.
@property (nonatomic) CGFloat cornerRadius;
/// The inset of the text label.
@property (nonatomic) UIEdgeInsets textInsets;
/// The color of the text label’s text.
@property (nonatomic, strong) UIColor * _Nullable textColor;
/// The font of the text label.
@property (nonatomic, strong) UIFont * _Nullable font;
/// The bottom offset from the screen’s bottom in portrait mode.
@property (nonatomic) CGFloat bottomOffsetPortrait;
/// The bottom offset from the screen’s bottom in landscape mode.
@property (nonatomic) CGFloat bottomOffsetLandscape;
/// If this value is <code>true</code> and SafeArea is available,
/// <code>safeAreaInsets.bottom</code> will be added to the <code>bottomOffsetPortrait</code> and <code>bottomOffsetLandscape</code>.
/// Default value: false
@property (nonatomic) BOOL useSafeAreaForBottomOffset;
/// The width ratio of toast view in window, specified as a value from 0.0 to 1.0.
/// Default value: 0.875
@property (nonatomic) CGFloat maxWidthRatio;
/// The shape of the layer’s shadow.
@property (nonatomic) CGPathRef _Nullable shadowPath;
/// The color of the layer’s shadow.
@property (nonatomic, strong) UIColor * _Nullable shadowColor;
/// The opacity of the layer’s shadow.
@property (nonatomic) float shadowOpacity;
/// The offset (in points) of the layer’s shadow.
@property (nonatomic) CGSize shadowOffset;
/// The blur radius (in points) used to render the layer’s shadow.
@property (nonatomic) CGFloat shadowRadius;
- (nonnull instancetype)init OBJC_DESIGNATED_INITIALIZER;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder;
- (void)layoutSubviews;
- (UIView * _Nullable)hitTest:(CGPoint)point withEvent:(UIEvent * _Null_unspecified)event SWIFT_WARN_UNUSED_RESULT;
- (nonnull instancetype)initWithFrame:(CGRect)frame SWIFT_UNAVAILABLE;
@end

@class UIViewController;
@class UIWindowScene;

SWIFT_CLASS("_TtC9VidyoCore11ToastWindow")
@interface ToastWindow : UIWindow
@property (nonatomic, strong) UIViewController * _Nullable rootViewController;
@property (nonatomic, getter=isHidden) BOOL hidden;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
- (void)addSubview:(UIView * _Nonnull)view;
- (void)becomeKeyWindow;
- (nonnull instancetype)initWithWindowScene:(UIWindowScene * _Nonnull)windowScene SWIFT_UNAVAILABLE;
- (nonnull instancetype)initWithFrame:(CGRect)frame SWIFT_UNAVAILABLE;
@end

@class UIResponder;

@interface UIApplication (SWIFT_EXTENSION(VidyoCore))
@property (nonatomic, readonly, strong) UIResponder * _Nullable nextResponder;
@end

@class NSBundle;

/// Starts a new vidyo call and provides the in-call UI, including call-control buttons bar, sharing and PiP mode.
/// The in-call UI is configured using a XIB file, and allows styling of the button bar: call end, volume control, audio/video mute and front/rear camera switch.
SWIFT_CLASS("_TtC9VidyoCore19VidyoViewController")
@interface VidyoViewController : UIViewController <UIGestureRecognizerDelegate>
/// :nodoc:
/// This method overrides <code>viewDidLoad()</code>
- (void)viewDidLoad;
/// :nodoc:
/// This method overrides <code>viewWillAppear()</code>
- (void)viewWillAppear:(BOOL)animated;
- (void)viewWillDisappear:(BOOL)animated;
/// :nodoc:
/// This method overrides <code>viewDidAppear()</code>
- (void)viewDidAppear:(BOOL)animated;
- (IBAction)endCall:(id _Nonnull)sender;
- (nonnull instancetype)initWithNibName:(NSString * _Nullable)nibNameOrNil bundle:(NSBundle * _Nullable)nibBundleOrNil OBJC_DESIGNATED_INITIALIZER;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)coder OBJC_DESIGNATED_INITIALIZER;
@end

@class UINavigationController;

@interface VidyoViewController (SWIFT_EXTENSION(VidyoCore)) <UINavigationControllerDelegate>
- (UIInterfaceOrientationMask)navigationControllerSupportedInterfaceOrientations:(UINavigationController * _Nonnull)navigationController SWIFT_WARN_UNUSED_RESULT;
@end


@class NSURL;

@interface VidyoViewController (SWIFT_EXTENSION(VidyoCore))
/// The designated initializer for joining a Vidyo call as guest.
/// This methid instantiates a new VidyoViewController and returns it.
/// \param guestLink the <code>GuestLink</code> that was clicked by the user.
///
/// \param onCallEnd a block to perform when the call ends (or fails)
///
+ (VidyoViewController * _Nonnull)createWithGuestLink:(NSURL * _Nonnull)guestLink onCallEnd:(void (^ _Nullable)(NSURL * _Nullable, NSInteger))onCallEnd SWIFT_WARN_UNUSED_RESULT;
/// The designated initializer for joining a Vidyo call as guest.
/// This methid instantiates a new VidyoViewController and returns it.
/// \param guestLink the <code>GuestLink</code> that was clicked by the user.
///
/// \param message String to display as a toast message during the test call.
///
/// \param duration the duration (in seconds) of the test call, afte which the call will automatically end.
///
/// \param onCallEnd a block to perform when the call ends (or fails)
///
+ (VidyoViewController * _Nonnull)createTestWithGuestLink:(NSURL * _Nonnull)guestLink message:(NSString * _Nonnull)message duration:(double)duration onCallEnd:(void (^ _Nullable)(NSURL * _Nullable, NSInteger))onCallEnd SWIFT_WARN_UNUSED_RESULT;
/// Creates a new <code>VidyoViewController</code> asynchronously, after validating the appId and call code.
/// \param appId the unique application Id, required for accessing the Vidyo API
///
/// \param callCode a unique String to identify the resource / call.
///
/// \param onCallEnd a block to perform when the call ends (or fails)
///
/// \param completion a block returning the initialized contorller and an <code>Error</code>, if occurred.
///
+ (void)createAsyncWithAppId:(NSString * _Nonnull)appId callCode:(NSString * _Nonnull)callCode onCallEnd:(void (^ _Nullable)(NSURL * _Nullable, NSInteger))onCallEnd completion:(void (^ _Nullable)(NSError * _Nullable, VidyoViewController * _Nullable))completion;
@end



@protocol UIViewControllerTransitionCoordinator;

@interface VidyoViewController (SWIFT_EXTENSION(VidyoCore))
/// :nodoc:
/// support all interface orientations
@property (nonatomic, readonly) UIInterfaceOrientationMask supportedInterfaceOrientations;
/// :nodoc:
/// support all interface orientations
@property (nonatomic, readonly) BOOL shouldAutorotate;
/// :nodoc:
/// support all interface orientations
- (void)viewWillTransitionToSize:(CGSize)size withTransitionCoordinator:(id <UIViewControllerTransitionCoordinator> _Nonnull)coordinator;
@end

#if __has_attribute(external_source_symbol)
# pragma clang attribute pop
#endif
#pragma clang diagnostic pop
#endif
